controllers/EtapaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Etapa;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EtapaController implements the CRUD actions for Etapa model.
 */
class EtapaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Etapa models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Etapa::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Etapa model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Etapa model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Etapa();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->numetapa]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Etapa model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->numetapa]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Etapa model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Etapa model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Etapa the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Etapa::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/LlevaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Lleva;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LlevaController implements the CRUD actions for Lleva model.
 */
class LlevaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Lleva models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Lleva::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Lleva model.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($numetapa, $código)
    {
        return $this->render('view', [
            'model' => $this->findModel($numetapa, $código),
        ]);
    }

    /**
     * Creates a new Lleva model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Lleva();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Lleva model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($numetapa, $código)
    {
        $model = $this->findModel($numetapa, $código);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Lleva model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($numetapa, $código)
    {
        $this->findModel($numetapa, $código)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Lleva model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $numetapa
     * @param string $código
     * @return Lleva the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($numetapa, $código)
    {
        if (($model = Lleva::findOne(['numetapa' => $numetapa, 'código' => $código])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;
use app\models\Lleva;
use app\models\Puerto;
use app\models\Etapa;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionCrud() {
        return $this->render("gestion");
    }
      
    public function actionConsulta3a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()
                ->select("dorsal")
                ->distinct()
                ->where("nomequipo='Banesto'")
                ->andWhere("edad BETWEEN 25 AND 32"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 3 con Active Record",
            "enunciado"=>"Listar el dorsal de los ciclistas que son de Banesto y cuya edad esta entre 25 y 32",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' AND edad BETWEEN 25 AND 32",
        ]);
    }
    
    public function actionConsulta3() {
        // mediante DAO
        $numero=Yii::$app
                ->db
                ->createCommand('SELECT count(dorsal) FROM ciclista WHERE nomequipo="Banesto" AND edad BETWEEN 25 AND 32')
                ->queryScalar();
        
        $dataProvider=new SqlDataProvider([
            'sql'=>'SELECT dorsal FROM ciclista WHERE nomequipo="Banesto" AND edad BETWEEN 25 AND 32',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 3 con DAO",
            "enunciado"=>"Listar el dorsal de los ciclistas que son de Banesto y cuya edad esta entre 25 y 32",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' AND edad BETWEEN 25 AND 32",
        ]);
    }
    
    public function actionConsulta4a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()
                ->select("dorsal")
                ->distinct()
                ->where("nomequipo='Banesto'")
                ->orWhere("edad BETWEEN 25 AND 32"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 4 con Active Record",
            "enunciado"=>"Listar el dorsal de los ciclistas que son de Banesto o cuya edad esta entre 25 y 32",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' OR edad BETWEEN 25 AND 32",
        ]);
    }
    
    public function actionConsulta4() {
        // mediante DAO
        $numero=Yii::$app
                ->db
                ->createCommand('SELECT count(dorsal) FROM ciclista WHERE nomequipo="Banesto" OR edad BETWEEN 25 AND 32')
                ->queryScalar();
        
        $dataProvider=new SqlDataProvider([
            'sql'=>'SELECT dorsal FROM ciclista WHERE nomequipo="Banesto" OR edad BETWEEN 25 AND 32',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 4 con DAO",
            "enunciado"=>"Listar el dorsal de los ciclistas que son de Banesto o cuya edad esta entre 25 y 32",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' OR edad BETWEEN 25 AND 32",
        ]);
    }
    
    public function actionConsulta8a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Puerto::find()
                ->select("nompuerto")
                ->distinct()
                ->where("altura BETWEEN 1000 AND 2000")
                ->orWhere("altura>2400"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nompuerto'],
            "titulo"=> "Consulta 8 con Active Record",
            "enunciado"=>"Listar el nombre de los puestos cuya altura entre 1000 y 2000 o que la altura sea mayor que 2400",
            "sql"=>"SELECT nompuerto FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura>2400",
        ]);
    }
    
    public function actionConsulta8() {
        // mediante DAO
        $numero=Yii::$app
                ->db
                ->createCommand('SELECT count(nompuerto) FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura>2400')
                ->queryScalar();
        
        $dataProvider=new SqlDataProvider([
            'sql'=>'SELECT nompuerto FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura>2400',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nompuerto'],
            "titulo"=> "Consulta 8 con DAO",
            "enunciado"=>"Listar el nombre de los puestos cuya altura entre 1000 y 2000 o que la altura sea mayor que 2400",
            "sql"=>"SELECT nompuerto FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura>2400",
        ]);
    }
    
    public function actionConsulta12a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Puerto::find()
                ->select("count(distinct dorsal) total")
                ->distinct()
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['total'],
            "titulo"=> "Consulta 12 con Active Record",
            "enunciado"=>"Listar el numero de ciclistas que hayan ganado algun puerto",
            "sql"=>"SELECT COUNT(DISTINCT dorsal) FROM puerto",
        ]);
    }
    
    public function actionConsulta12() {
        // mediante DAO
        $numero=1;
        
        $dataProvider=new SqlDataProvider([
            'sql'=>'SELECT COUNT(DISTINCT dorsal) numero FROM puerto',
            'totalCount'=>$numero,
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['numero'],
            "titulo"=> "Consulta 12 con DAO",
            "enunciado"=>"Listar el numero de ciclistas que hayan ganado algun puerto",
            "sql"=>"SELECT COUNT(DISTINCT dorsal) FROM puerto",
        ]);
    }
    
    public function actionConsulta14a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Puerto::find()
                ->select("avg(altura) total")
                ->distinct()
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['total'],
            "titulo"=> "Consulta 14 con Active Record",
            "enunciado"=>"Indicar la altura media de los puertos",
            "sql"=>"SELECT AVG(altura) FROM puerto",
        ]);
    }
    
    public function actionConsulta14() {
        // mediante DAO
        $numero=1;
        
        $dataProvider=new SqlDataProvider([
            'sql'=>'SELECT AVG(altura) numero FROM puerto',
            'totalCount'=>$numero,
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['numero'],
            "titulo"=> "Consulta 14 con DAO",
            "enunciado"=>"Indicar la altura media de los puertos",
            "sql"=>"SELECT AVG(altura) FROM puerto",
        ]);
    }
    
    public function actionConsulta18a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Lleva::find()
                ->select("dorsal,código,COUNT(*) total")
                ->distinct()
                ->groupBy("dorsal,código"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal','código','total'],
            "titulo"=> "Consulta 18 con Active Record",
            "enunciado"=>"Listar el dorsal del ciclista con el codigo de maillot y cuantas veces ese ciclista ha llevado ese maillot",

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php
use yii\helpers\Html;

echo Html::a('Ciclistas', ['ciclista/index'], ['class' => 'btn btn-primary btn-large']);

echo Html::a('Equipo', ['equipo/index'], ['class' => 'btn btn-primary btn-large']);

echo Html::a('Etapa', ['etapa/index'], ['class' => 'btn btn-primary btn-large']);

echo Html::a('Lleva', ['lleva/index'], ['class' => 'btn btn-primary btn-large']);

echo Html::a('Maillot', ['maillot/index'], ['class' => 'btn btn-primary btn-large']);

echo Html::a('Puerto', ['puerto/index'], ['class' => 'btn btn-primary btn-large']);

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de Seleccion 3</h1>

        <p class="lead">Modulo 3 - Unidad 2</p>
    </div>

 <div class="body-content">
        <div class="row">
            <!-- 
            boton de consulta
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 3</h3>
                        <p>Listar el dorsal de los ciclistas que son de Banesto y cuya edad esta entre 25 y 32</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta3a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta3'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta
            -->
            <!-- 
            boton de consulta
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 4</h3>
                        <p>Listar el dorsal de los ciclistas que son de Banesto o cuya edad esta entre 25 y 32</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta4a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta4'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta
            -->
            <!-- 
            boton de consulta
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 8</h3>
                        <p>Listar el nombre de los puertos cuya altura entre 1000 y 2000 o que la altura sea mayor que 2400</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta8a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta8'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta
            -->
            <!-- 
            boton de consulta
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 12</h3>
                        <p>Listar el numero de ciclistas que hayan ganado algun puerto</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta12a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta12'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta
            -->
            <!-- 
            boton de consulta
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 14</h3>
                        <p>Indicar la altura media de los puertos</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta14a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta14'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta
            -->
            <!-- 
            boton de consulta
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 18</h3>
                        <p>Listar el dorsal del ciclista con el codigo de maillot y cuantas veces ese ciclista ha llevado ese maillot</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta18a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta18'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta
            -->
        </div>
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>

    <div class="jumbotron">
        <h2><?= $titulo ?></h2>

        <p class="lead"><?= $enunciado ?></p>
        <p class="well"><?= $sql ?></p>
    </div>
 
    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
    ]); ?> 
 